#!/usr/bin/perl -w

# GUI para LinuxSMS (by zOmbie) creado originalmente por Igor Castang
# Modificado por Kali (kali@kalimotxo.net) para LinuxSMS v0.33

use Tk;

my $HOME = $ENV{HOME};



my $win= MainWindow->new();
$win->configure(-title=>"XLinuxSMS",-background=>"red");
$win->minsize("250","100");
my $menu=$win->Frame(-relief=>'groove',-borderwidth=>3,-background=>'purple',)->pack('-side'=>'top',-fill=>'x');

my $topf=$win->Frame()->pack(-side=>'top',-fill=>'x');
my $number_l=$topf->Label(-text=>'Numero del movil')->pack();
my $number_f=$topf->Entry(-width=>10,-background=>'white')->pack(pady=>1);
my $server_l=$topf->Label(-text=>'Servidor')->pack();
my $server_f=$topf->Entry(-width=>10,-background=>'white')->pack(pady=>1);
my $message_l=$topf->Label(-text=>'Mensaje a enviar')->pack();
my $message_f=$topf->Entry(-width=>30,-background=>'white')->pack(pady=>1);
my $send_b=$topf->Button(-text=>'Enviar mensaje',-command=>\&send)->pack();

#list name in adress book
@name=&list_addressbook();
my $num_lab=$menu->Label(-text=>'Agenda')->pack();
my $number_i=$menu->Listbox(-height=>0)->pack();
   $number_i->insert('end',@name);
   $number_i->bind('<Button-1>',sub { $number_f->delete(0,'end'); $number_f->insert(0,&addressbook($name[$number_i->curselection]))});

#list iserver name 

@server=&list_server();
my $ser_lab=$menu->Label(-text=>'Lista de servidores disponibles')->pack();
my $server_i=$menu->Listbox(-height=>0)->pack();
   $server_i->insert('end',@server);
   $server_i->bind('<Button-1>',sub { $server_f->delete(0,'end'); $server_f->insert(0,$server[$server_i->curselection])});


#

MainLoop();


sub list_addressbook() {
    my $ADDRESSBOOK = $HOME."/.linuxsms/addressbook";
    my ($LINE, $N);
    open (ADDRESSBOOK, $ADDRESSBOOK) or die "error\!, can\'t open $ADDRESSBOOK\n";
    while ($LINE = <ADDRESSBOOK>) {
        if (($LINE !~ /^$/) && ($LINE !~ /^#/)) {
            if ($LINE =~ /^(.*)\:(\d{9})$/) {
	     push(@name,$1);
            }
        }
    }
    close (ADDRESSBOOK);
    return(@name);
}

sub list_server() {
    open(LINSMS,"linuxsms -server|");
   while ($LINE = <LINSMS>) {
        if ($LINE !~ /register/) {
            if ($LINE =~ /^- (\[\*\]|\[-\]) : (.*\w*) : (.*):(.*):(.*):(.*)$/) {
	     push(@server,$2);
	    }
        }
    }
    close (LINSMS);
    return(@server);
} 

sub send() {
$msg=$message_f->get();
$serv=$server_f->get();
$numb=$number_f->get();
$cmd="linuxsms -sms:\"$msg\" -number:\"$numb\" -server:$serv ";
print(`$cmd`);
}


sub addressbook() {
    my $ADDRESSBOOK = $HOME."/.linuxsms/addressbook";
    my ($LINE, $N);
    open (ADDRESSBOOK, $ADDRESSBOOK) or die $c_bold_red.$c_blink_red."error\!, can\'t open $ADDRESSBOOK".$c_default."\n";
    while ($LINE = <ADDRESSBOOK>) {
        if (($LINE !~ /^$/) && ($LINE !~ /^#/)) {
            if ($LINE =~ /^(.*)\:(\d{9})$/) {
                if ($_[0] eq $1) { $N = $2; }
            }
        }
    }
    close (ADDRESSBOOK);
    if (! $N) { die $c_bold_red.$c_blink_red."error\!, name $_[0] was not found in $ADDRESSBOOK".$c_default."\n"; }
    return($N);
}
